<template>
  <div class="contract-directions">
    <div class="contract-directions__header">
      <button data-qa="btnContractDirectionsHeader" @click="setViewState(VIEW_STATES.main)">
        <i class="icon chevron-left" />
        Мультистоповые
      </button>
      <div class="title">
        {{ service.serviceTitle }}
      </div>
    </div>

    <ObTable
      ref="directionTable"
      :columns="columns"
      :page-limit="15"
      :remote-opt="{
        method: api.contract.getServiceDirectionsMultistop,
        arguments: {
          uuid: service.uuid
        }
      }"
      :remote-trigger="service.serviceCaste === 'MULTISTOP' ? service.uuid : undefined"
      group-by="locationFromTitle"
      :group-title-html="tableGroupTitleHtml"
      :show-add-button="isDraft"
      :functional-panel="true"
      add-button-text="Добавить маршрут"
      data-qa="contractDirectionsTable"
      @add="onAddDirection"
    >
      <div slot="dropdownMenu" slot-scope="{ data }">
        <ObMenuDropdown
          :items="getDropdownItems(data)"
        />
      </div>
      <div slot="locationTo" slot-scope="{ data }">
        <span
          v-for="(item, index) in data.item.points"
          :key="item.locationUuid"
          class="location-to"
          :class="index === 0 && '--first'"
        >
          <span class="location-to__icon"><i class="icon city-sm"/></span>{{ item.address + (index !== data.item.points.length - 1 ? ',  ' : '') }}
        </span>
      </div>
      <template slot="noneContent">
        <div class="title">Сейчас услуга действует для всех маршрутов по указанному тарифу</div>
        <ObButton
          v-if="isDraft"
          label="Добавить маршрут"
          type="flat"
          data-qa="addDirection"
          @click="onAddDirection"
        />
      </template>
    </ObTable>
    <ObModal
      ref="directionModal"
      :title-second="titleSecondModal"
      title="Маршрут"
      size="large"
      data-qa="contractDirection"
    >
      <DirectionForm
        :data-source="editedData"
        @on-disable-direction="deleteDirection"
        @submit="saveDirection"
      />
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import { mapState, mapGetters, mapMutations } from 'vuex'
import ObTable from 'common-components/src/obComponents/obTable'
import DirectionForm from '@/components/Contract/detail/services/directions/FormMultistop'
import ObModal from 'common-components/src/obComponents/obModal'
import ObButton from 'common-components/src/obComponents/obButton'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import { formatNumber } from 'common-components/src/helpers/common'

export default {
  name: 'ContractDirectionsListMultistop',
  components: {
    ObTable,
    DirectionForm,
    ObModal,
    ObMenuDropdown,
    ObButton
  },
  data () {
    return {
      api,
      editedData: {}
    }
  },
  computed: {
    ...mapState({
      contract: state => state.contract.contract,
      service: state => state.contract.editedService
    }),
    ...mapGetters({
      isDraft: 'contract/isDraft',
      VIEW_STATES: 'contract/VIEW_STATES',
      isVatPayer: 'contract/isDoerVatPayer'
    }),
    columns () {
      return [
        {
          title: ' ',
          key: 'locationFromTitle',
          sortDisable: true,
          html: () => '',
          width: 130
        },
        {
          title: 'Куда',
          key: 'locationToTitle',
          slotName: 'locationTo'
        },
        {
          title: 'Тариф (без ндс)',
          key: 'tariff',
          html: (data) => this.tariffHtml(data),
          isAlignRight: true
        },
        {
          headerHtml: () => this.vatRateHtml(this.service),
          key: 'vatAmount',
          html: (data) => this.vatHtml(data),
          isAlignRight: true
        },
        {
          title: 'Итоговый тариф',
          key: 'total',
          html: (data) => this.totalPrice(data),
          isAlignRight: true
        },
        {
          title: ' ',
          slotName: 'dropdownMenu',
          sortDisable: true,
          action: true
        }
      ]
    },
    titleSecondModal () {
      if (!this.isDraft) {
        return 'Просмотр'
      }
      return this.editedData.directionUuid ? 'Редактирование' : 'Добавление'
    }
  },
  methods: {
    ...mapMutations({
      setViewState: 'contract/setViewState'
    }),
    onAddDirection () {
      this.editedData = {}
      this.$refs.directionModal.open()
    },
    async deleteDirection ({ uuid }) {
      try {
        await api.contract.deleteDirectionMultistop({ uuid })
        this.$notification({
          type: 'system_notification_success',
          message: `Маршрут удален`
        })
        setTimeout(() => {
          this.$refs.directionTable.loadData()
        }, 500)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка удаления маршрута`
        })
      }
    },
    async saveDirection ({ formData }) {
      formData.serviceUuid = this.service.uuid
      try {
        if (formData.directionUuid) {
          await api.contract.updateDirection({ data: formData, uuid: formData.directionUuid })
        } else {
          await api.contract.createDirectionMultistop({ data: formData, uuid: this.service.uuid })
        }
        this.$notification({
          type: 'system_notification_success',
          message: `Маршрут ${this.editedService ? 'обновлен' : 'добавлен'}`
        })
        this.$refs.directionModal.close()
        setTimeout(() => {
          this.$refs.directionTable.loadData()
        }, 500)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} маршрута`
        })
      }
    },
    async selectDirection (data) {
      console.log(data)
      try {
        let res = await api.contract.getDirectionDetail({ uuid: data.directionUuid })

        res = {
          ...res,
          ...res.tariffs
        }

        this.editedData = { ...res }
        this.$refs.directionModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки данных маршрута`
        })
      }
    },
    getDropdownItems (data) {
      if (!this.isDraft) {
        return []
      }
      return [
        {
          title: 'Удалить маршрут',
          className: 'menu-button-danger',
          method: () => this.deleteDirection({ uuid: data.item.uuid })
        }
      ]
    },
    toHtml (data) {
      return `<div class="cell-to-direction"><i class="icon ${data.to_icon}"></i><span>${data.to}</span></div>`
    },
    tariffHtml (data) {
      if (!data.tariff?.priceWithoutVat) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariff?.priceWithoutVat / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    vatHtml (data) {
      return data.vatRate ? (formatNumber(data.tariff?.vatPrice / 100, { dot: 2 }) + ' ₽') : ``
    },
    vatRateHtml (data) {
      return `Величина НДС ${data.vatRate ? data.vatRate + '%' : ''}`
    },
    totalPrice(data) {
      if (!data.tariff?.priceWithVat) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariff?.priceWithVat / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    tableGroupTitleHtml (value) {
      return `<div class="cell-to-direction"><i class="icon city-sm"></i><span>${value}</span></div>`
    }
  }
}
</script>

<style lang="scss" scoped>
  .contract-directions {
    display: flex;
    flex-direction: column;
    height: 100%;
    background-color: $background-white;
    border-radius: 3px;
    &__header {
      display: flex;
      align-items: center;
      min-height: 60px;
      padding: 20px 13px;
      border-bottom: 1px $color-grey-border solid;
      button {
        display: flex;
        align-items: center;
        margin: 0;
        padding: 5px;
        background-color: transparent;
        border: none;
        color: $color-blue-navy-blue;
        font-size: 16px;
        line-height: 20px;
        outline: none;
        cursor: pointer;
        .icon {
          margin-right: 10px;
          font-size: 18px;
        }
      }
      .title {
        margin-left: 50px;
        font-family: Roboto, sans-serif;
        font-style: normal;
        font-weight: normal;
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: $color-text-base;
      }
    }
    &-functional {
      display: flex;
      align-items: center;
      flex: 1;
    }
    &__select-inline {
      padding: 7px 12px;
      margin-right: 12px;
      background: $lavender;
      border-radius: 19px;
      &.disabled {
        background: $color-white-lilac;
        pointer-events: none;
      }
      span {
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.2px;
        color: $color-grey-span;
      }
    }
    &::v-deep {
      .ob-func-panel__controls-side:last-child {
        flex-grow: 2;
        justify-content: space-between;
      }
    }
    .location-to {
      line-height: 24px;
      &__icon {
        margin-right: 5px;
        margin-left: 8px;
        .icon {
          font-size: 14px;
          color: $color-blue-navy-blue;
        }
      }
      &.--first {
        .location-to__icon {
          margin-left: 0;
        }
      }
    }
  }
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';
  .contract-directions {
    table {
      min-width: auto!important;
    }
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    .ob-table-inner {
      flex-grow: 2;
      .ob-menu-dropdown-container:not(.--opened) {
        opacity: 0;
        pointer-events: none;
      }
      tr:hover {
        .ob-menu-dropdown-container {
          opacity: 1;
          pointer-events: all;
        }
      }
      td {
        &:last-child {
          .td-container {
            justify-content: flex-end;
          }
        }
      }
      .cell-to-direction {
        display: flex;
        align-items: center;
        .icon {
          margin-right: 10px;
          font-size: 14px;
          color: $color-blue-navy-blue;
        }
      }
    }
  }
</style>
